#ifndef DICTIONNAIRE_H
#define DICTIONNAIRE_H
#include <stdbool.h>

typedef unsigned int uint;
typedef struct mot {
    char* chaine;
    uint taille;
} mot;

typedef struct noeud noeud;

typedef struct branche {
    mot* etiquette;
    noeud* noeud_fils;
    struct branche* suivant;
} branche;

struct noeud {
    char* contenu;
    branche* liste_fils;
};

typedef struct dictionnaire {
    noeud* racine;
} dictionnaire;

typedef struct maillon {
    mot* cle;
    char* valeur;
    struct maillon* suivant;
    struct maillon* précédent;
} maillon;

typedef struct liste_cle_valeur {
    maillon* debut;
    maillon* fin;
} liste_cle_valeur;

dictionnaire* creer_dictionnaire_vide();
char* get(dictionnaire* dict, mot* cle, char* defaut);
void set(dictionnaire* dict, mot* cle, char* valeur);
liste_cle_valeur* elements(dictionnaire* d);
void detruire_liste_cle_valeur(liste_cle_valeur* l);

#endif
